package cs155.hw3;

import java.awt.Color;

/**
  This represents color objects, where the red, green, and blue components are non-negative doubles.
  When  converting to a Color with multiply by 255 and coerce to integers in the range [0,255]
 **/
public class Color3D {
    public static final Color3D 
	WHITE = new Color3D(1d,1d,1d),
        BLACK = new Color3D(0d,0d,0d);

    public double red=1.0, green=1.0, blue=1.0;

    public Color3D(double r, double g, double b) {
	red=r; green=g; blue=b;
    }


    public Color toColor() {
	int r=(int)(red*255), g=(int)(green*255), b=(int)(blue*255);
        if (r<0) r=0; else if (r>255) r=255;
        if (g<0) g=0; else if (g>255) g=255;
        if (b<0) b=0; else if (b>255) b=255;
        return new Color(r,g,b);
    }

    public Color3D add(Color3D c) {
	return new Color3D(red+c.red, green+c.green, blue+c.blue);
    }

    public Color3D times(Color3D c) {
	return new Color3D(red*c.red, green*c.green, blue*c.blue);
    }

    public Color3D scale(double d) {
        return new Color3D(d*red, d*green, d*blue);
    }

}
