package cs155.hw3;

import java.awt.*;
import javax.swing.*;


/**
 This represents 3D lights with several parameters including Color3D values for
  the ambient, diffuse, and specular illumination as well as the attenuation
  coefficients: attC, attL, attQ - representing the Constant, Linear, and Quadratic components
  Finally we include an intensity to make it easy to increase the brightness of a all components of a light.
 **/

public class Light3D {
  public Point3D location = new Point3D(0d,0d,0d);
  public double intensity = 1.0;
  public Color3D 
     ambient=Color3D.BLACK,
     diffuse=Color3D.WHITE,
     specular=Color3D.WHITE;
  public double attC=1.0, attL=0.001, attQ = 0.00001; 

  public Light3D(){}

  public Light3D( Point3D new_location ){
	location= new Point3D(new_location);
  }

  public Light3D( Point3D new_location, double intensity ){
	location= new Point3D(new_location);
        this.intensity = intensity;
  }

  public Light3D( Point3D new_location, double intensity, Color3D amb, Color3D dif, Color3D sp  ){
	location= new Point3D(new_location);
        this.intensity = intensity;
        this.ambient=amb; this.diffuse = dif; this.specular=sp;
  }

    /**
      This needs to be completed for hw2
     **/
    public double attenuation(double length) {
        return 1.0/(attC + attL*length + attQ*length*length);
    }


    /**
      This needs to be completed for hw2
     **/
    public double specular(Point3D lightVec, Point3D normal, Point3D eyeVec, int hardness) {
        if (lightVec.dot(normal)< 0) return 0.0;

	Point3D H = lightVec.add(eyeVec).normalize();
        return Math.pow(H.dot(normal),hardness);
    }


  public double diffuse (Point3D lightVec, Point3D normal){	
    double cosA = normal.dot(lightVec);
    if (cosA < 0) return 0.0; 
    else return (cosA); 
  }

}
 

   

