package cs155.hw3;

/** 
  A Point3D is a triple of doubles that can represent   a point or a vector. 
  There are many operations that can be performed on points.
  They are included in this class.
**/

//import java.awt.*;
//import javax.swing.*;

public class Point3D //extends Panel
{
    public double x=0.0, y=0.0, z=0.0, w=1.0;

	public Point3D(double x, double y, double z)
	{
		this.x = x;
		this.y = y;
		this.z = z;
	}

	public Point3D(Point3D m)
	{	
		x = m.x;
		y = m.y;
		z = m.z;
		
	}

         public String toString() {
             return "point3d("+x+","+y+","+z+")";
          }

       public Point3D subtract(Point3D q) {
         return new Point3D(x-q.x, y-q.y,z-q.z);
      }

       public Point3D add(Point3D q) {
         return new Point3D(x+q.x, y+q.y,z+q.z);
      }

   public Point3D scalarMult(double a) {
     return new Point3D(x*a, y*a, z*a);
   } 

    public double norm(Point3D q) {
	return q.dot(q);
    }

    public double length(Point3D q) {
	return Math.sqrt(q.dot(q));
    }




	public double dot(Point3D q)
	{
		
		double dp =   x*q.x+y*q.y+z*q.z;
		return dp;
	}

	public Point3D cross(Point3D q)
	{	
		
		return new Point3D(y*q.z - q.y*z, q.x*z - x*q.z, x*q.y - q.x*y);

	}


	public Point3D normalize() 
	{
		double length = this.length();
		return new Point3D(x/ length, y/length, z/length);
	}
	
	public double length() 
	{
		return Math.sqrt((x*x) + (y*y) + (z*z));
	}

	public Point3D translate(double x_dist, double y_dist, double z_dist)
	{
		return new Point3D (x + x_dist, y + y_dist, z + z_dist);

	}	

	public static void main (String args[]){
  	Point3D p = new Point3D(1, 2, 2);
	Point3D q = new Point3D(1, 2, 3);
	double pd = p.dot(q);
	System.out.println("dot = " +pd);
	System.out.println("Normalized point x value= " + p.normalize().x + " y value= " + p.normalize().y 
            +  " z value = " + p.normalize().z);
	p.length();
	System.out.println("p.length() = " + p.length());

	Point3D s = p.cross(q);
	System.out.println("cross of p and q (x) = " + s.x + "  y value = " + s.y + " z value = " + s.z);
	}
	
}

   

