package cs155.hw3;

/**   
  A Ray3D consists of a point and a (normalized) direction.
  We think of a ray as defining the position of a point at any
  given time t. At time zero it is at the starting point, and
  then it moves at 1 unit per second in the specified direction.
**/

public class Ray3D
 {
  public Point3D p,d;
  private Point3D origin = new Point3D(0d,0d,0d);

     /**
       This represents a 3D ray with a specified origin point p and direction d.
       The direction of a ray is a normalized vector!
     **/
  public Ray3D(Point3D d)
 {
    this.p = origin; 
    this.d = d.normalize();
    this.d.w=0;  // this is a critical step! Its needed for transforms to work correctly
  }

  public Ray3D(Point3D p, Point3D d)
 {
    this.p = p; 
    this.d = d.normalize();
    this.d.w=0;
  }

     /**
	This returns the point along the ray corresponding to time t,
	assuming the point starts at the ray origin at time 0 and moves
	at one unit of distance per unit of time
     **/

   public Point3D atTime(double t)
   {
      return new Point3D((p.x+t*d.x), p.y + t*d.y, p.z+t*d.z);
   } 

}

  

