package cs155.hw3;

/**
  This class stores two pieces of information about the intersection of a Ray with an object:
   the distance to the intersection along the ray and
   the normal to the object at that intersection point.
 **/
public class RayHit {
    public static RayHit NO_HIT = new RayHit(Double.POSITIVE_INFINITY,null, null);

    public RayHit(double distance,Point3D normal, Object3D obj) {
	this.distance = distance;
	this.normal=normal;
        this.obj = obj;

	if (this.normal != null){
	    this.normal = this.normal.normalize();
	    this.normal.w = 0;
	}
    }

    public double distance; // distance along ray to the first intersection (or -1 if there is no intersection)
    public Point3D normal; // normal of the object at the intersection point
    public Object3D obj; // innermost primitive object that this ray hits...

    public String toString() {
	return "rayhit("+distance+","+normal+","+obj+")";
    }

}
