package cs155.hw3;


import java.awt.Color;

/**
 * class represents a 3D sphere
 */

public class Triangle3D extends Object3D
{
    public Point3D p,q,r,a,b,c,a1,b1,c1,normal;
   

     public Triangle3D (Point3D p, Point3D q, Point3D r, Material m)
     {
         this.insideMat = this.outsideMat = m;
	 this.p = p;
	 this.q = q;
	 this.r = r;
         this.a = p.subtract(q);
         this.b = r.subtract(q);
         this.c = p.subtract(r);
         normal = b.cross(a).normalize();
         this.a1 = a.cross(normal);
         this.b1 = normal.cross(b);
         this.c1 = normal.cross(c);
     }

      
    /**
       This tests if the ray intersects the triangle and returns a RayHit object. 
     **/

     public RayHit rayIntersect(Ray3D r) {
      Point3D P = r.p, D=r.d;
      Point3D QP = q.subtract(P);
      double 
          t = QP.dot(normal)/D.dot(normal);
      if (t <= epsilon) return RayHit.NO_HIT;
      Point3D V1 = r.atTime(t);
      if (pointInTriangle(V1)) 
          return new RayHit(t,normal,this);
       else return RayHit.NO_HIT;
     }

    /** 
     Test if the specified point in the triangle plane is actually within the triangle
     More precisely, it tests if it is in the triangular prism
     which is parallel to the normal of the plane and whose base is the triangle
    **/
    
    public boolean pointInTriangle(Point3D v1) {
        Point3D v = v1.subtract(q);
	return ((v.dot(a1)>=0) && (v.dot(b1)>=0) && (v.subtract(a).dot(c1)>=0));
    }


     
}

  

