;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  hw2.scm
;; the idea here is to read and evaluate expressions using the scheme evaluator
;; the expression contains objects which are then added to the scene and displayed
;;
;; You can run this using the command
;;    % java -cp jscheme.jar:. jscheme.REPL hw2.scm
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(import "cs155.hw3.*")

(use-module "jlib/Swing.scm")
(use-module "elf/basic.scm")

(define s (Scene3D.))
(define rc (NewRayCanvas3D. s 200 200))
(define t (textfield "scene1.scm"))
(define b (button "load" (action(lambda(e)
   (let ((f (open-input-file (readstring t))))
      (clear s)
      (tryCatch (for-each (lambda(x) (.add s x)) (eval (read f))) (lambda(e) (display {ERROR: [e]\n})))
      (.active$# rc #t)
      (.refresh rc)
    )))))

(define clear
  (button "clear" 
    (action(lambda(e) 
      (clear s) 
      (.refresh rc)
      (.active$# rc #f)
    ))
  )
)
     

(define w (window "raytracer"
  (border (center rc)
    (south (row t b clear (button "exit" (action(lambda(e) (System.exit 0)))))))))



(define (clear s)
 (.objs$ s (Group3D.))
 (.numLights$ s 0)
)

       

(.pack w)
(.show w)
